"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _templateObject = _taggedTemplateLiteral(["\n      display: grid;\n      width: ", ";\n      height: ", ";\n      grid-template-columns: ", ";\n      grid-template-rows: ", ";\n      grid-gap: ", ";\n    "], ["\n      display: grid;\n      width: ", ";\n      height: ", ";\n      grid-template-columns: ", ";\n      grid-template-rows: ", ";\n      grid-gap: ", ";\n    "]),
    _templateObject2 = _taggedTemplateLiteral(["\n      border-radius: 2px;\n      box-shadow: 1px 2px 4px 0 rgba(0, 0, 0, 0.3);\n      background: white;\n    "], ["\n      border-radius: 2px;\n      box-shadow: 1px 2px 4px 0 rgba(0, 0, 0, 0.3);\n      background: white;\n    "]);

var _react = require("react");

var _react2 = _interopRequireDefault(_react);

var _styledComponents = require("styled-components");

var _styledComponents2 = _interopRequireDefault(_styledComponents);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _taggedTemplateLiteral(strings, raw) { return Object.freeze(Object.defineProperties(strings, { raw: { value: Object.freeze(raw) } })); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var RSGrid = function (_Component) {
  _inherits(RSGrid, _Component);

  function RSGrid(props) {
    _classCallCheck(this, RSGrid);

    var _this = _possibleConstructorReturn(this, (RSGrid.__proto__ || Object.getPrototypeOf(RSGrid)).call(this, props));

    _this.state = { seleted: null };
    _this.numbers = Array(props.cols * props.rows).fill(0);
    return _this;
  }

  _createClass(RSGrid, [{
    key: "render",
    value: function render() {
      var _this2 = this;

      var Grid = _styledComponents2.default.div(_templateObject, function (props) {
        return props.width ? props.width : "inherit";
      }, function (props) {
        return props.height ? props.height : "inherit";
      }, function (props) {
        return props.cols ? "repeat(" + props.cols + ",1fr);" : "repeat(1,1fr);";
      }, function (props) {
        return props.rows ? "repeat(" + props.rows + ",1fr);" : "repeat(1,1fr);";
      }, function (props) {
        return props.gap ? props.gap : "0";
      });
      var GridElement = _styledComponents2.default.div(_templateObject2);
      return _react2.default.createElement(
        Grid,
        {
          width: this.props.width,
          height: this.props.height,
          cols: this.props.cols,
          rows: this.props.rows,
          gap: this.props.gap
        },
        this.numbers.map(function (ele, i) {
          return _react2.default.createElement(GridElement, {
            key: i,
            className: "RSGelement-" + i,
            onClick: function onClick() {
              _this2.setState({ seleted: i });
              _this2.props.onSelected(i, "RSGelement-" + i);
            },
            style: {
              boxShadow: _this2.state.seleted === i ? "1px 2px 16px 0 rgba(0,0,0,0.3)" : "1px 2px 4px 0 rgba(0,0,0,0.3)"
            }
          });
        })
      );
    }
  }]);

  return RSGrid;
}(_react.Component);

exports.default = RSGrid;